

use12f675	equ	1

	if	use12f675 == 1

#include "p12f675.inc"
	processor 12f675
	list	f=inhx8m
	__config (_INTRC_OSC_NOCLKOUT & _MCLRE_ON & _WDT_OFF & _CP_OFF & _CPD_OFF & _BODEN_OFF)
	
delay_ms_arg	equ	0x20
delay_s_arg		equ	0x21
add_arg			equ	0x22

	else
	
#include "p12c508a.inc"
	
	processor 12c508a
	list	f=inhx8m
	__config (_IntRC_OSC & _MCLRE_ON & _WDT_OFF & _CP_OFF)
	
delay_ms_arg	equ	0x07
delay_s_arg		equ	0x08
add_arg			equ	0x09

	endif

	; Start of code

	org     0x00				; reset vector
	goto    main

delay_ms
	movf	delay_ms_arg, f
	btfss	STATUS, Z
	goto	outer_loop
	retlw	0
outer_loop
	movlw	0xF9
	movf	add_arg, w
inner_loop
	movlw	0xFF	
	addwf	add_arg, f
	btfss	STATUS, Z
	goto	inner_loop
	nop
	decfsz	delay_ms_arg, F
	goto	outer_loop
	retlw	0

delay_s
	movlw	0xFA
	movwf	delay_ms_arg
	call	delay_ms
	movlw	0xFA
	movwf	delay_ms_arg
	call	delay_ms
	movlw	0xFA
	movwf	delay_ms_arg
	call	delay_ms
	movlw	0xFA
	movwf	delay_ms_arg
	call	delay_ms
	decfsz	delay_s_arg, f
	goto	delay_s
	retlw	0

main
	movlw	0x00
	movwf	GPIO
	
	movlw	0x3D
	if	use12f675 == 1
	
	; 12F675
	bsf		STATUS, RP0				; select register bank 1
	
	movwf	TRISIO
	
	movlw	0x00					; All A/D off
	movwf	ANSEL
	
	bcf		STATUS, RP0				; select register bank 0
	
	movlw	0x07					; Comparators disconnected
	movwf	CMCON
	else
	
	; 12C508A
	tris	GPIO
	endif

	
main_loop 						; Power button pressing loop

	movlw	0x03				; 3 Seconds per pass
	movwf	delay_s_arg
	call	delay_s
	
	btfsc	GPIO, 0				; System now on? Exit if so
	goto	infinite_loop

	bsf		GPIO, 1				; Assert power button
	
	movlw	0xFA				; 250ms delay
	movwf	delay_ms_arg
	call	delay_ms
	
	movlw	0xFA				; 250ms delay
	movwf	delay_ms_arg
	call	delay_ms
	
	bcf		GPIO, 1				; De assert power button
	
	goto	main_loop
	
infinite_loop					; Done till next power on
	goto	infinite_loop
	
	end